<?php
/*
 * Copyright 2005 - 2011  Zarafa B.V.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3, 
 * as published by the Free Software Foundation with the following additional 
 * term according to sec. 7:
 *  
 * According to sec. 7 of the GNU Affero General Public License, version
 * 3, the terms of the AGPL are supplemented with the following terms:
 * 
 * "Zarafa" is a registered trademark of Zarafa B.V. The licensing of
 * the Program under the AGPL does not imply a trademark license.
 * Therefore any rights, title and interest in our trademarks remain
 * entirely with us.
 * 
 * However, if you propagate an unmodified version of the Program you are
 * allowed to use the term "Zarafa" to indicate that you distribute the
 * Program. Furthermore you may use our trademarks where it is necessary
 * to indicate the intended purpose of a product or service provided you
 * use it in accordance with honest practices in industrial or commercial
 * matters.  If you want to propagate modified versions of the Program
 * under the name "Zarafa" or "Zarafa Server", you may only do so if you
 * have a written permission by Zarafa B.V. (to acquire a permission
 * please contact Zarafa at trademark@zarafa.com).
 * 
 * The interactive user interface of the software displays an attribution
 * notice containing the term "Zarafa" and/or the logo of Zarafa.
 * Interactive user interfaces of unmodified and modified versions must
 * display Appropriate Legal Notices according to sec. 5 of the GNU
 * Affero General Public License, version 3, when you propagate
 * unmodified or modified versions of the Program. In accordance with
 * sec. 7 b) of the GNU Affero General Public License, version 3, these
 * Appropriate Legal Notices must retain the logo of Zarafa or display
 * the words "Initial Development by Zarafa" if the display of the logo
 * is not reasonably feasible for technical reasons. The use of the logo
 * of Zarafa in Legal Notices is allowed for unmodified and modified
 * versions of the software.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *  
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

?>
<?php
require_once('server/core/class.filter.php');
require_once(PATH_PLUGIN_DIR . '/spreed/server/dat/timezones.inc');
require_once(PATH_PLUGIN_DIR . '/spreed/server/dat/languages.inc');
require_once(PATH_PLUGIN_DIR . "/spreed/server/inc/class.spreedparticipant.php");

function init(){

}

function getModuleName(){
	return "spreeditemmodule";
}

function getModuleType(){
	return "item";
}

function addDialogMenuItems($data) {
	// ignore all dialogs except "readmail"
	if (strncmp($data["task"], "readmail", 8) != 0) return;
	$data["buttons"][] = array(
		'id' => "seperator",		// This is how a seperator is added.
		'name' => "",
		'title' => "",
		'callback' => ""
	);
	$data["buttons"][] = array(
		'id' => "spreed_call",		// HTML ID and CSS class of the menu item.
		'name' => dgettext("plugin_spreed", "Spreed"),	
		'title' => dgettext("plugin_spreed", "Setup a Spreed Meeting"),		
		'callback' => "eventPluginSpreedListMailMenuSetupCall"		
	);
}

function getOptionList($keyValList, $sel){
    $retStr = '';
    foreach($keyValList as $key => $val){
        $retStr .= "<option value='$key'".($sel == $key ? " selected='selected'" : '').">".utf8_to_windows1252($val)."</option>";
    }
    return $retStr;
}


function getDialogTitle(){
	return dgettext("plugin_spreed", "Spreed Meeting");
}

function getIncludes(){
	return array(
			"client/modules/contactitemmodule.js",
			"client/widgets/tablewidget.js",
			"plugins/spreed/dialogs/spreed.js",
			"client/layout/js/date-picker.js",
			"client/layout/js/date-picker-language.js",
			"client/layout/js/date-picker-setup.js",
			"client/layout/css/date-picker.css",
			"client/widgets/datetimepicker.js",
			"client/widgets/combineddatetimepicker.js",
			"client/widgets/datepicker.js",
			"client/widgets/timepicker.js",
			"plugins/spreed/".getModuleName().".js",
			"plugins/spreed/client/css/plugin.spreeddialog.css"
		);
}

function getJavaScript_onload(){
    $userNameArray = SpreedParticipant::extractNameArrayFromNameField(windows1252_to_utf8($GLOBALS["mapisession"]->getFullName()));
    $userNameArray['email'] = strtolower(windows1252_to_utf8($GLOBALS["mapisession"]->getEmail()));

    /* Filter all the fields, so XSS attacks are no longer possible. */
    $filter = new filter();
    foreach($userNameArray as $key => $val){
        $userNameArray[$key] = addslashes($filter->html2text($val));
    }
?>
    /**
    * The initialization code of the Spreed Module, this function
    * is called when the spreed module is started from any location.
    * It determines which addresses were selected and how these should
    * be added on the contact list of invitees.
    */
    var i, action;

    if(module){
        module.init(moduleID);
        module.createParticipantsTable('<?=$userNameArray['firstname']?>', '<?=$userNameArray['lastname']?>', '<?=$userNameArray['organisation']?>', '<?=$userNameArray['email']?>');

        dhtml.addEvent(module, dhtml.getElementById('newfirstname'), "keydown", eventSpreedKeyPressedInInput);
        dhtml.addEvent(module, dhtml.getElementById('newlastname'), "keydown", eventSpreedKeyPressedInInput);
        dhtml.addEvent(module, dhtml.getElementById('neworganisation'), "keydown", eventSpreedKeyPressedInInput);
        dhtml.addEvent(module, dhtml.getElementById('newemail'), "keydown", eventSpreedKeyPressedInInput);
    }

    webclient.menu.showMenu();

    if(window.windowData && window.windowData.actions && module){
        for(i = 0; i < window.windowData.actions.length; i++){
            if(window.windowData.actions[i].action && window.windowData.actions[i].data){
                module.execute(window.windowData.actions[i].action, window.windowData.actions[i].data);
            }
        }
    }


<?php
} // getJavaSctipt_onload

function getBody() {
    $default_lang = substr($GLOBALS["language"]->getSelected(), 0, 2);
    if(false && !array_key_exists($GLOBALS['spreed_languages'], $default_lang)){
        $default_lang = 'en';
    }
?>
    <div class='overlay hidden' id='overlay'>
        <span id='overlayText'><?=dgettext('plugin_spreed', "Busy setting up the Spreed Conference")?>...</span>
        <div id='icon_loading' class='icon_loading'></div>
        <div class='overlayButton'><input id='startConfButton' class="startbutton hidden" type="button" value="<?=dgettext('plugin_spreed', "Join the Spreed Meeting")?>" onClick="module.openConferenceMeeting(); return false;"></div>
    </div>
    <div id='spreeddialog'>
      <div class='properties'>
        <table border=0 style="width:100%; padding-right: 4px;">
            <tr>
                <td class='propertynormal propertywidth'><label for="title"><?=dgettext('plugin_spreed', "Title")?>:</label></td>
                <!-- <td><input id="title" class="fieldsize" type="text" value="" size="40" onkeydown="if ((event.which && event.which == 13) || (event.keyCode && event.keyCode == 13)) module.searchAlfresco();"></td> -->
                <td class='propertynormal'><input id="title" class="field fieldfull" type="text" value=""></td>
            </tr>
        </table>
      </div>
      <div class='properties'>
        <table border=0 style="width: 100%;">
            <tr>
                <td class='propertynormal propertywidth'><label for="start"><?=dgettext('plugin_spreed', "Start time")?>:</label></td>
                <td class='propertynormal propertywidth' id='start_time'></td>
                <td class='propertynormal propertywidth'><label for="end"><?=dgettext('plugin_spreed', "End time")?>:</label></td>
                <td class='propertynormal propertywidth' id='end_time'></td>
                <td class='propertynormal ltzcol'>
                    <select name='timezone' id='timezone' class='fieldfull' onChange='eventSpreedTimezoneChanged();'>
                        <?php echo getOptionList($GLOBALS['spreed_timezones'], date_default_timezone_get()); ?>
                    </select>
                </td>
                <td>&nbsp;</td>
            </tr>
        </table>
      </div>
      <div class='properties'>
        <div id='spreedparticipants' class='participantList'>
        </div>
        <div id='newparticipant'>
        <table border=0 style="width: 100%;" cellpadding=0 cellspacing=0>
            <tr>
                <td class='fnamecol'><input id="newfirstname" class="field" type="text" value="" onkeyup="eventSpreedKeyPressedInInput"></td>
                <td class='lnamecol'><input id="newlastname" class="field" type="text" value="" onkeyup="eventSpreedKeyPressedInInput"></td>
                <td class='orgcol'><input id="neworganisation" class="field" type="text" value="" onkeyup="eventSpreedKeyPressedInInput"></td>
                <td class='emailcol'><input id="newemail" class="field" type="text" value="" onkeyup="eventSpreedKeyPressedInInput"></td>
                <td class='ltzcol'>
                <select name='language' id='newlanguage' class='fieldfull'>
                    <?php echo getOptionList($GLOBALS['spreed_languages'], $default_lang); ?>
                </select>
                </td>
                <td class='ltzcol' id='newtimezonetd'></td>
                <td class='addcol'>
                <div class="icon_spreed_user" id="newstatus" title="<?=dgettext('plugin_spreed', "Promote to moderator")?>" alt="U" onClick="module.statusClicked(0);">&nbsp;</div>
                <div class="icon_spreed_add" id="spreed_add_button" onmouseover="this.className+=' icon_spreed_add_over';" onmouseout="this.className='icon_spreed_add';" onclick="module.addParticipantInput();">&nbsp;</div>
                </td>
            </tr>
        </table>
        </div>
        <div id='participantWarning' class='spreedWarning hidden'>
        </div>
      </div>
      <div class='properties' id='attachmentbox'>
        <table border=0 style='width: 100%; padding-right: 6px;'>
            <tr>
                <td class="propertynormal propertywidth" valign="top">
                    <input class="button" type="button" value="<?=dgettext('plugin_spreed', "Attachments")?>:" onclick="eventAttachFilesClicked();">
                </td>
                <td valign="top">
                    <div class="fieldfull spreedattachments" id="itemattachments">&nbsp;</div>
                </td>
            </tr>
        </table>
        <div id='uploadWarning' class='spreedWarning hidden'>
        </div>
      </div>
      <div style='padding: 4px; width: 99%;'>
        <textarea id="description" class='fieldfull description' cols="60" rows="4"></textarea>
      </div>
    </div>

<?php
} // getBody 
function getMenuButtons(){
	return array(
			array(
				'id'=>"spreed_call",
				'name'=>dgettext('plugin_spreed', "Setup Meeting"),
				'title'=>dgettext('plugin_spreed', "Setup Meeting"),
				'callback'=>'eventStartCallClicked'
			),
			array(
				'id'=>"seperator",
				'name'=>'',
				'title'=>'',
				'callback'=>''
			),
			array(
				'id'=>"attachment",
				'name'=>dgettext('plugin_spreed', "Attach Files"),
				'title'=>dgettext('plugin_spreed', "Attach Files"),
				'callback'=>'eventAttachFilesClicked'
			),
			array(
				'id'=>"addressbook",
				'name'=>dgettext('plugin_spreed', "Address Book"),
				'title'=>dgettext('plugin_spreed', "Address Book"),
				'callback'=>'eventAddressBookClicked'
			),
			array(
				'id'=>"seperator",
				'name'=>'',
				'title'=>'',
				'callback'=>''
			),
			array(
				'id'=>"delete",
				'name'=>dgettext('plugin_spreed', "Clear"),
				'title'=>dgettext('plugin_spreed', "Clear contents"),
				'callback'=>'eventClearClicked'
            )
		);
}
?>
