<?php
/*
 * Copyright 2005 - 2011  Zarafa B.V.
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License, version 3, 
 * as published by the Free Software Foundation with the following additional 
 * term according to sec. 7:
 *  
 * According to sec. 7 of the GNU Affero General Public License, version
 * 3, the terms of the AGPL are supplemented with the following terms:
 * 
 * "Zarafa" is a registered trademark of Zarafa B.V. The licensing of
 * the Program under the AGPL does not imply a trademark license.
 * Therefore any rights, title and interest in our trademarks remain
 * entirely with us.
 * 
 * However, if you propagate an unmodified version of the Program you are
 * allowed to use the term "Zarafa" to indicate that you distribute the
 * Program. Furthermore you may use our trademarks where it is necessary
 * to indicate the intended purpose of a product or service provided you
 * use it in accordance with honest practices in industrial or commercial
 * matters.  If you want to propagate modified versions of the Program
 * under the name "Zarafa" or "Zarafa Server", you may only do so if you
 * have a written permission by Zarafa B.V. (to acquire a permission
 * please contact Zarafa at trademark@zarafa.com).
 * 
 * The interactive user interface of the software displays an attribution
 * notice containing the term "Zarafa" and/or the logo of Zarafa.
 * Interactive user interfaces of unmodified and modified versions must
 * display Appropriate Legal Notices according to sec. 5 of the GNU
 * Affero General Public License, version 3, when you propagate
 * unmodified or modified versions of the Program. In accordance with
 * sec. 7 b) of the GNU Affero General Public License, version 3, these
 * Appropriate Legal Notices must retain the logo of Zarafa or display
 * the words "Initial Development by Zarafa" if the display of the logo
 * is not reasonably feasible for technical reasons. The use of the logo
 * of Zarafa in Legal Notices is allowed for unmodified and modified
 * versions of the software.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *  
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

?>
<?php
/**
 * Spreed Plugin
 *
 * Integrates Spreed in to the Zarafa environment
 *
 * Author: Siem Kok <s.kok@zarafa.com>
 *
 */


class Pluginspreed extends Plugin {

    /**
    * Constructor
    */
    function Pluginspreed(){

    }


    /**
    * Function initializes the Plugin and registers all hooks
    *
    * @return void
    */
    function init(){
        // on load the login data is fetched so they can be used to login 
        //$this->registerHook('server.index.login.success');
        //$this->registerHook('server.main.include.jsfiles');

        // event to add the 'insert Spreed Link' to the 'new email window' menubar and the 'attachments window' menubar.
        $this->registerHook('server.dialog.general.setup.getmenubuttons');
        $this->registerHook('server.dialog.general.setup.getincludes');
    }


    /**
    * Function is executed when a hook is triggered by the PluginManager
    *
    * @param string $eventID the id of the triggered hook
    * @param mixed $data object(s) related to the hook
    * @return void
    */
    function execute($eventID, &$data){
        switch($eventID){
            case "server.index.login.success":
                $this->login();
                break;
            case "server.main.include.jsfiles":
                $this->loadjs($data);
                break;
            case "server.dialog.general.setup.getmenubuttons":
                //if($data['task'] == 'attachments'){
                    //$this->attachmentAddButton($data);
                //} else{
                    $this->modifyDialogMenu($data);
                //}
                break;
            case "server.dialog.general.setup.getincludes":
                $this->dialogGetIncludes($data);
                break;
        }
    }

    /**  
    * Function gets includes for a dialog
    * Adds the plugin.spreed.js and css files
    *
    * @param mixed $data object(s) related to the hook
    * @return void
    */
    function dialogGetIncludes(&$data) {
        // ignore all dialogs except "readmail" && "createmail" && "contact"
        if (strncmp($data["task"], "readmail", 8) != 0 && strncmp($data["task"], "createmail", 9) != 0 && strncmp($data["task"], "contact", 7) != 0) return;
        //$data["includes"][] = $this->getPluginPath(). "client/plugin.spreed.js";
        //$data["includes"][] = $this->getPluginPath(). "client/css/plugin.spreedicon.css";
    }


    /**
    * Function is triggered (as well) when the login into the WA was sucessfully
    *
    * @return void
    */
    function login() {
        // only login when executed with a username in the session!
        if (! $_SESSION["username"] ) return;

    }

    /** ----------------- GUI STUFF (BUTTONS ETC) --------------------------------------------------------------- */

    /**
    * Function is triggered when initializing the WA and adds the spreedmodule (JS) so it will be always loaded
    *
    * @param mixed $data object(s) related to the hook
    * @return void
    */
    function loadjs(&$data) {
        //$data["files"][] = $this->getPluginPath(). "client/plugin.spreed.js";
    }


    /**
    * Function adds the Spreed-Link button to the menu of a dialog
    *
    * @param mixed $data object(s) related to the hook
    * @return void
    */
    function modifyDialogMenu(&$data) {
        // ignore all dialogs except "readmail" && "createmail" && "distlist" && "namedistlist"
        if (strncmp($data["task"], "readmail", 8) != 0 && strncmp($data["task"], "createmail", 9) != 0 && strncmp($data["task"], "contact", 7) != 0 && strncmp($data["task"], "distlist", 8) != 0 && strncmp($data["task"], "namedistlist", 12) != 0) return;
        $data["buttons"][] = array(
                        'id'=>"seperator",
                        'name'=>"",
                        'title'=>"",
                        'callback'=>""
                    );
        $data["buttons"][] = array(
                        'id'=>"spreed_call",
                        'name'=>dgettext('plugin_spreed', "Spreed Meeting"),
                        'title'=>dgettext('plugin_spreed', "Setup a conference meeting in Spreed"),
                        'callback'=> strncmp($data["task"], "contact", 7) != 0 && strncmp($data["task"], "distlist", 8) != 0 && strncmp($data["task"], "namedistlist", 12) != 0 ? "eventPluginspreedListMailMenuSetupCall" : "eventPluginspreedListContactMenuSetupCall"
                    );
    }
}
?>
